VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmMain 
   Caption         =   "VB Watch"
   ClientHeight    =   5655
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8775
   LinkTopic       =   "Form1"
   ScaleHeight     =   377
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   585
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ImageList imgList 
      Left            =   5280
      Top             =   1800
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   16777215
      ImageWidth      =   18
      ImageHeight     =   18
      MaskColor       =   255
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   6
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":0000
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":0442
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":0884
            Key             =   ""
         EndProperty
         BeginProperty ListImage4 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":0CC6
            Key             =   ""
         EndProperty
         BeginProperty ListImage5 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":1108
            Key             =   ""
         EndProperty
         BeginProperty ListImage6 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":145A
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.TreeView tvProject 
      Height          =   4935
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   8535
      _ExtentX        =   15055
      _ExtentY        =   8705
      _Version        =   393217
      Sorted          =   -1  'True
      Style           =   7
      Checkboxes      =   -1  'True
      ImageList       =   "imgList"
      Appearance      =   1
   End
   Begin VB.PictureBox picButtons 
      BorderStyle     =   0  'None
      Height          =   375
      Left            =   1560
      ScaleHeight     =   25
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   473
      TabIndex        =   0
      Top             =   5160
      Width           =   7095
      Begin VB.CommandButton cmdOpen 
         Caption         =   "&Open project"
         Height          =   375
         Left            =   1800
         TabIndex        =   5
         Top             =   0
         Width           =   1695
      End
      Begin VB.CommandButton cmdAddErr 
         Caption         =   "&Add error handler"
         Height          =   375
         Left            =   5400
         TabIndex        =   3
         Top             =   0
         Width           =   1695
      End
      Begin VB.CommandButton cmdExit 
         Caption         =   "&Exit"
         Height          =   375
         Left            =   0
         TabIndex        =   2
         Top             =   0
         Width           =   1695
      End
      Begin VB.CommandButton cmdSettings 
         Caption         =   "&Settings"
         Height          =   375
         Left            =   3600
         TabIndex        =   1
         Top             =   0
         Width           =   1695
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

'Copyright (C) 2004 Kristian. S.Stangeland

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Dim Parser As New clsVBParser
Dim Project As New clsProject
Dim OpenSave As New clsOpenSave

Public Function GetImageIndex(sName As String) As Long

Select Case LCase(sName)
Case "form": GetImageIndex = 2
Case "class": GetImageIndex = 3
Case "module": GetImageIndex = 4
Case "usercontrol": GetImageIndex = 5
End Select

End Function

Public Function GUIName(sName As String) As String

Select Case LCase(sName)
Case "form": GUIName = "Forms"
Case "class": GUIName = "Class Modules"
Case "module": GUIName = "Modules"
Case "usercontrol": GUIName = "User Controls"
End Select

End Function

Public Sub ProcessControls(ControlName As String)

Dim Tell As Long, Tmp As Long, Node As Node, sName As String

tvProject.Nodes.Clear

Select Case LCase(ControlName)
Case "treeview"

    Set Node = tvProject.Nodes.Add(, , "Project", Project.Variables("Name"), 1)
    
    Node.Bold = True
    Node.Expanded = True

    For Tmp = 2 To 5

        Select Case Tmp
        Case 2: sName = "form"
        Case 3: sName = "class"
        Case 4: sName = "module"
        Case 5: sName = "usercontrol"
        End Select

        Set Node = tvProject.Nodes.Add("Project", tvwChild, sName & "Folder", GUIName(sName), 6)

        Node.Expanded = True

        For Tell = 0 To Project.ObjectCount
            If Project.ObjectType(Tell) = sName Then
                tvProject.Nodes.Add sName & "Folder", tvwChild, , Project.ObjectName(Tell), GetImageIndex(Project.ObjectType(Tell))
            End If
        Next
        
        If Node.Children <= 0 Then tvProject.Nodes.Remove Node.Index
    Next

End Select

End Sub

Private Sub cmdAddErr_Click()

Dim Tell As Long

For Tell = 0 To Project.ObjectCount
    Parser.LoadCode Project.ObjectPath(Tell)
    Parser.AddErrorHandler frmSettings.txtProcBegin, frmSettings.txtProcEnd
    Parser.SaveCode Project.ObjectPath(Tell)
Next

MsgBox "Error handler is added! Remember to append the file 'modDebugErr.bas' if you want it to work correctly.", vbInformation, "Error handler"

End Sub

Private Sub cmdExit_Click()

Unload Me

End Sub

Private Sub cmdOpen_Click()

OpenSave.Filter = "Project Files (*.vbp)" & Chr(0) & "*.vbp"
OpenSave.OpenFile Me.hwnd, "Open Project"

If OpenSave.File = "" Then Exit Sub

Project.ParseProject OpenSave.File
ProcessControls "treeview"

End Sub

Private Sub cmdSettings_Click()

frmSettings.Show

End Sub

Private Sub Form_Resize()

tvProject.Width = Me.ScaleWidth - tvProject.Left - 8
tvProject.Height = Me.ScaleHeight - tvProject.Top - 52

picButtons.Top = tvProject.Top + tvProject.Height + 16
picButtons.Left = Me.ScaleWidth - picButtons.ScaleWidth - 8

End Sub
